/*
   Program: ADD_REC()
   System: GRUMPFISH LIBRARY
   Author: Greg Lief
   Copyright (c) 1988-94, Greg Lief
   CA-Clipper 5.x Version
   Compile instructions: clipper addrec /n /w
   Attempts to APPEND BLANK in multi-user environment
*/

#include "grump.ch"
#include "inkey.ch"

#ifdef CLIPPER52
function Add_Rec(nWait,lReleaseRecLocks)
#else
function Add_Rec(nWait)
#endif

// establish condition to wait for record to be appended
// if user passed parameter, use that as number of seconds to wait;
// otherwise, wait until the user presses ESC or clicks right button
local nStart

#ifdef MOUSE
local waitcond := if(nWait == NIL, ;
                     { | nKey | nKey := lastkey(), ;
                                nKey <> K_ESC .and. nKey <> K_RIGHT_DOWN }, ;
                     { || seconds() - nStart < nWait} )
#else
local waitcond := if(nWait == NIL, { || lastkey() <> K_ESC}, ;
                                      { || seconds()-nStart < nWait})
#endif

if len(alias()) == 0    // no database in use
   return .f.
endif

#ifdef CLIPPER52
dbAppend(lReleaseRecLocks)
#else
dbAppend()
#endif

if ! neterr()
   return .t.
else
   nStart := seconds()
   do while eval(waitcond)
      append blank
      if ! neterr()
         return .t.
      endif
   enddo
   Err_Msg( { NETERR_MSG } )
endif
return .f.

* end function Add_Rec()
*--------------------------------------------------------------------*

* eof addrec.prg
