/*
    Program: BLANKSCR()
    System: GRUMPFISH LIBRARY
    Author: Greg Lief
    Copyright (c) 1988-93, Greg Lief
    CA-Clipper 5.x version
    Compile instructions: clipper blank1 /n /w
    *Mouseable*
    Blanks screen to prevent monitor wear and tear during inactivity
*/

#include "setcurs.ch"
#include "grump.ch"

function blankscr(nDelay)
local nStart := seconds()
local nTop
local nBottom
local cBuffer
do while nextkey() == 0 .and. seconds() - nStart < nDelay
enddo
if nextkey() == 0     // do while loop timed out with no keypress
   GFSaveEnv(.t., 0, 'w/n')
   scroll()
   ColorSet(C_MESSAGE)
   nBottom := (nTop := int(maxrow() / 2) - 2) + 3
   SINGLEBOX(nTop, 25, nBottom, 53)
   @ nTop + 1, 27 ssay 'The screen has been saved'
   @ nTop + 2, 27 ssay 'Press any key to continue'
   setcolor('w/n')
   cBuffer := savescreen(nTop, 25, nBottom, 53)
   nStart := seconds()

   #ifdef MOUSE
   HideMouseCursor()
   #endif
   while ginkey() == 0
      if seconds() - nStart > 10
         scroll(nTop, 25, nBottom, 53, 0)
         nTop := if(nTop > maxrow() - 4, 0, nTop + 1)
         nBottom := if(nBottom == maxrow(), 3, nBottom + 1)
         restscreen(nTop, 25, nBottom, 53, cBuffer)
         nStart := seconds()
      endif
   end
   #ifdef MOUSE
   ShowMouseCursor()
   #endif
   GFRestEnv()
endif
return NIL

* eof blank1.prg
