/*
   Program: BLANKSCRN()
   System: GRUMPFISH LIBRARY
   Author: Greg Lief
   Copyright (c) 1989-93, Greg Lief
   CA-Clipper 5.x Version
   Compile instructions: clipper blank2 /n /w
   *Mouseable*

   Blanks the screen to prevent monitor wear and tear during inactivity
   Designed for use with GET-IT's N_NOKEY() function

   GET-IT is a trademark of Communications Horizons.
*/

#include "setcurs.ch"
#include "grump.ch"


function blankscrn
local nTop
local nBottom
local cBuffer
local nStart
GFSaveEnv(.t., 0, 'w/n')
scroll()
ColorSet(C_MESSAGE)
nBottom := (nTop := int(maxrow() / 2) - 2) + 3
SINGLEBOX(nTop, 25, nBottom, 53)
@ nTop + 1, 27 say 'The screen has been saved'
@ nTop + 2, 27 say 'Press any key to continue'
setcolor('w/n')
cBuffer := savescreen(nTop, 25, nBottom, 53)
nStart  := seconds()

#ifdef MOUSE
HideMouseCursor()
#endif
while ginkey() == 0
   if seconds()-nStart > 10
      scroll(nTop, 25, nBottom, 53, 0)
      nTop := if(nTop > maxrow() - 4, 0, nTop + 1)
      nBottom := if(nBottom == maxrow(), 3, nBottom + 1)
      restscreen(nTop, 25, nBottom, 53, cBuffer)
      nStart := seconds()
   endif
end
#ifdef MOUSE
ShowMouseCursor()
#endif

GFRestEnv()
return NIL

* eof blank2.prg
