/*
    Program: BLANKSCR2()
    System: GRUMPFISH LIBRARY
    Author: Greg Lief
    Copyright (c) 1988-93, Greg Lief
    CA-Clipper 5.x Version
    Compile instructions: clipper blank3 /n /w
    *Mouseable*
    A whimsical screen-saver (a dancing smiley face)

    Calls: GFRAND()      (function in RAND.PRG)
*/

#include "setcurs.ch"
#include "grump.ch"
#include "inkey.ch"

static cTemp

function blankscr2(nDelay, cPassword)
local nStart := seconds()
local nTop
local nBottom
local cBuffer
local bCondition

while nextkey() == 0 .and. seconds() - nStart < nDelay
enddo

if nextkey() == 0     // timed out with no keypress
   GFSaveEnv(.t., 0, '+w/n')
   scroll()
   nTop := gfrand(maxrow() + 1)
   nBottom := gfrand(maxcol() + 1)
   nStart := seconds()
   @ nTop, nBottom say chr(2)
   if cPassword == NIL
      bCondition := { || ginkey() == 0 }
   else
      cTemp      := ''
      cPassword  := upper(cPassword)
      bCondition := { || password(cPassword) }
   endif

   #ifdef MOUSE
   HideMouseCursor()
   #endif
   while eval(bCondition)
      if seconds() - nStart > 2.5
         scroll(nTop, nBottom, nTop, nBottom, 0)
         nTop := gfrand(maxrow() + 1)
         nBottom := gfrand(maxcol() + 1)
         @ nTop, nBottom say chr(2)
         nStart := seconds()
      endif
   end
   #ifdef MOUSE
   ShowMouseCursor()
   #endif

   GFRestEnv()
endif

return NIL


static function password(cPassword)

local nKey := inkey()
local lRetVal := .t.

if nKey > 0
   do case
      case nKey <> K_ENTER
         cTemp += upper(chr(nKey))

      case nKey == K_ENTER
         if cTemp == cPassword
            lRetVal := .f.   // forces exit from screen blank loop above
         else
            cTemp := ''
            tone(MUSIC_RASPBERRY,1)
         endif

      case nKey == K_BS .and. ! empty(cTemp)
         cTemp := left(cTemp, len(cTemp) - 1)
   endcase
endif

return lRetVal


* eof blank3.prg
