/*
   Function: CHECKAPPTS()
   System:   GRUMPFISH LIBRARY
   Author:   Greg Lief
   Copyright (c) 1988-93, Greg Lief
   CA-Clipper 5.x Version
   Compile instructions: clipper chk_appt /n /w
   Compile with "/dMOUSE" for mouseability
   Calls: POPDATE() (see POPDATE.PRG)
   Files used: APPT.DBF and APPTDATE.NTX
*/

#include "inkey.ch"
#include "grump.ch"

function checkappts(cDir, cUser, nDays)
local nWorkarea := select()
local cOldscrn
local dDate := date()
local cFile
local nKey
local nMidrow
local nMidcol

default cUser to ''
default nDays to 0
cFile := if(cDir = NIL, '', cDir + if(right(cDir, 1) <> '\','\','')) + 'appt'
if file(cFile + '.dbf') .and. file(cFile + 'date' + indexext()) .and. ;
      net_use(cFile, .f., cFile + 'date')
   if dbseek( dtos(dDate) + cUser ) .and. ! deleted()
      GFSaveEnv(, 0)
      ColorSet(C_MESSAGE)
      nMidrow := int( maxrow() / 2)
      nMidcol := int( (maxcol() + 1) / 2)
      cOldscrn := shadowbox(nMidrow - 2, nMidcol - 16, nMidrow + 2, ;
                            nMidcol + 15, 2)
      tone(MUSIC_WAITON[1], 1)
      tone(MUSIC_WAITON[2], 1)
      @ nMidrow,     nMidcol - 14 say 'Press F2 to check calendar,'
      @ nMidrow + 1, nMidcol - 14 say 'or any other key to proceed'
      ColorSet(C_MESSAGEBLINK)
      if nDays == 0
         @ nMidrow - 1, nMidcol - 14 say 'You have appointments today!'
      else
         @ nMidrow - 1, nMidcol - 14 say 'Appointments for ' + dtoc(dDate) + '!'
      endif

      nKey := ginkey( 0 )

      byebyebox(cOldscrn)
      dbCloseArea()

      #ifdef MOUSE
      if nKey == K_LEFT_DOWN .and. GFLastRow() == nMidRow  ;
                             .and. GFLastCol() >= nMidCol - 8 ;
                             .and. GFLastCol() <= nMidCol - 7
         nKey := K_F2
      endif
      #endif

      if nKey == K_F2 
         popdate()
      endif
      GFRestEnv()
   else
      use
   endif
endif
select(nWorkarea)
return NIL

* eof chk_appt.prg
