/*
   File:   GFPQ.CH
   System: GRUMPFISH LIBRARY
   Author: Greg Lief
   Copyright (c) 1993-4 Greg Lief
   Preprocessor directives for use with background print queue functions
*/

#ifndef _GFPQ_DEFINED

#xcommand INITIALIZE PRINT QUEUE          ;
          CHECK EVERY <x> SECONDS         ;
                                    =>    ;
          gfontick("gfpq", 18 * <x>)


// if you don't specify a time, the default is 5 seconds
#xcommand INITIALIZE PRINT QUEUE    =>    ;
          gfontick("gfpq", 90)


// front end for GFPQADDJOB()

#xcommand ADD PRINT JOB <cFile>           ;
          [ PORT <cPort> ]                ;
          [ BUFFER <nBuff> ]              ;
          [ <delete:DELETE> ]             ;
          [ TITLE <cTitle> ]              ;
          [ COPIES <nCopies> ]            ;
          [ <priority:PRIORITY,URGENT> ]  ;
                                    =>    ;
          GFPQAddJob( <cFile>, <cPort>, <nBuff>, <.delete.>, ;
                      <cTitle>, <nCopies>, <.priority.> )


// GFPQKILLJOB() and GFPQCURRJOB() were rendered obsolete by
// GFPQSTATUS(), effective April 27, 1994
#xtranslate GFPQCURRJOB()    => GFPQSTATUS()
#xtranslate GFPQKILLJOB(<x>) => GFPQSTATUS()

#define _GFPQ_DEFINED

#endif

// end of file GFPQ.CH
