/*
    Function: GKeyBasic()
    Purpose:  test for hot keys and all basic keys used for exiting GETs
              this is a separate function so that the code need not be
              duplicated in each special keypress module
    Author:   Greg Lief
    Copyright (c) 1991-93 Greg Lief
    Dialect:  CA-Clipper 5.x
*/

#include "inkey.ch"
#include "getexit.ch"

#ifdef MOUSE
   #include "grump.ch"
#endif

function GKeyBasic( get, key )
local bKeyBlock := SetKey(key)
local ret_val := .t.

#ifdef MOUSE
local aGets
#endif

// check for SET KEY first
if bKeyBlock != NIL
   GetDoSetKey(bKeyBlock, get)
else
   do case

      #ifdef MOUSE

      case ( key == K_LEFT_DOWN ) .or. ( key == K_LEFT_DBLCLICK )

         aGets := activeGets()  // see GETSYS.PRG or GETSYS52.PRG

         // if we are only editing a single GET, fall out
         if len(aGets) == 1
            get:exitState := GE_WRITE
         else
            get:killFocus()
            aeval( aGets, {| g, e | g:setFocus(), ;
                                  iif( GFLastRow() == g:row() .and. ;
                                       GFLastCol() >= g:col() .and. ;
                                       GFLastCol() <  g:col() + len(g:buffer), ;
                                       get:exitState := 0 - e, ), ;
                                       g:killFocus()} )
            get:setFocus()
         endif

      #endif

      case ( key == K_UP )
         get:exitState := GE_UP

      case ( key == K_SH_TAB )
         get:exitState := GE_UP

      case ( key == K_DOWN )
         get:exitState := GE_DOWN

      case ( key == K_TAB )
         get:exitState := GE_DOWN

      case ( key == K_ENTER )
         get:exitState := GE_ENTER

      #ifdef MOUSE
      case ( key == K_ESC ) .or. ( key == K_RIGHT_DOWN )
      #else
      case ( key == K_ESC )
      #endif
         if ( Set(_SET_ESCAPE) )
            get:undo()
            get:exitState := GE_ESCAPE
         endif

      case ( key == K_PGUP )
         get:exitState := GE_WRITE

      case ( key == K_PGDN )
         get:exitState := GE_WRITE

      case ( key == K_CTRL_HOME )
         get:exitState := GE_TOP

      // both ^W and ^End terminate the READ (the default)
      case (key == K_CTRL_W)
         get:exitState := GE_WRITE

      otherwise
         ret_val := .f.
   endcase
endif
return (ret_val)
