/*
     Program: MENUH()
     System: GRUMPFISH LIBRARY
     Author: Greg Lief
     Copyright (c) 1988-93, Greg Lief
     CA-Clipper 5.x version
     Compile instructions: clipper menuh /n/w/a
     Creates horizontal bounce-bar menu
*/

MEMVAR promptList

#include "grump.ch"

#ifdef MOUSE
   #include "grumpm.ch"
#endif

#define NextItem(msg) substr(msg, 1, at("$", msg) - 1)
#define Truncate(msg) substr(msg, at("$", msg) + 1, len(msg) - at("$", msg))

function menuh(nRow, nCol, nSpacing, cPrompts, cMessages, cColor, nChoice)
local cPrompt
local msg
local ptr1 := 1
local ptr2 := 1
local oldcolor
local lOldMsgCtr
local nOldMsgRow
local lOldWrap
local menulist := {}

default nChoice to 1

GFSaveEnv()
lOldMsgCtr := set(_SET_MCENTER, .T.)  // set message to be centered
// if no message row has been established already, use bottom row
if (nOldMsgRow := set(_SET_MESSAGE)) == 0
   set(_SET_MESSAGE, maxrow())
endif
lOldWrap := set(_SET_WRAP, .T.)     // SET WRAP ON

default cMessages to ''
default cColor to ColorSet(C_MENU_UNSELECTED, .T.) + ',' + ;
                  ColorSet(C_MENU_SELECTED, .T.)
setcolor(cColor)
if '$' $ cPrompts
   cPrompts := trim(cPrompts)
   cPrompts := cPrompts + ;
                if(substr(cPrompts, len(cPrompts), 1) == '$', '', '$')
   do while ptr1 < len(cPrompts)
      cPrompt := NextItem(cPrompts)
      @ nRow, nCol prompt cPrompt message NextItem(cMessages)
      cPrompts := Truncate(cPrompts)
      cMessages := Truncate(cMessages)
      nCol += len(cPrompt) + nSpacing
   enddo
   menu to nChoice
endif
// restore previous message and wrap settings
set(_SET_MCENTER, lOldMsgCtr)
set(_SET_MESSAGE, nOldMsgRow)
set(_SET_WRAP, lOldWrap)
GFRestEnv()
return(nChoice)

* end function MenuH()
*--------------------------------------------------------------------*

* eof menuh.prg
