/*
    Program: PRINTOK()
    System: GRUMPFISH LIBRARY
    Author: Greg Lief
    Copyright (c) 1988-93, Greg Lief
    CA-Clipper 5.x Version
    Compile instructions: clipper printok /n /w
    Special thanks to Robert Scher and Matt Amis for their input
    Ensures that printer is on-line before printing
*/

#include "grump.ch"
#include "inkey.ch"

function printok(sez)
local ret_val := .t.
local oldscrn
local oldconsole
local key := 0
local nMidRow := int(maxrow() / 2)
local nMidCol := int((maxcol() + 1) / 2)
sez := (sez == NIL)    // if no parameter passed, assume use of @...says
if ! isprinter()
   gfsaveenv(, 0, colorset(C_ERRORMESSAGE, .t.))
   oldscrn := ShadowBox(nMidRow - 3, nMidCol - 28, nMidRow + 2, nMidCol + 28, 3, 'Printer Error')
   @ nMidRow - 2, nMidCol - 26 ssay 'Common problems include: out of paper, paper jammed,'
   @ nMidRow - 1, nMidCol - 26 ssay 'off-line, printer unplugged, cable loose or unplugged'
   @ nMidRow,     nMidCol - 26 ssay 'Please check your printer and press any key to resume'
   @ nMidRow + 1, nMidCol - 26 ssay '(or press the Esc key to abort this print operation)'
   oldconsole := set(_SET_CONSOLE, .F.)
   #ifdef MOUSE
   do while ! isprinter() .and. key <> K_ESC .and. key <> K_RIGHT_DOWN
   #else
   do while ! isprinter() .and. key <> K_ESC
   #endif
      tone(MUSIC_ALERT, 1)
      tone(MUSIC_ALERT, 1)
      key := ginkey(0)
   enddo
   set(_SET_CONSOLE, oldconsole)
   ByeByeBox(oldscrn)
   gfrestenv()
   #ifdef MOUSE
   if key == K_ESC .or. key == K_RIGHT_DOWN
   #else
   if key == K_ESC
   #endif
      ret_val := .f.
   endif
endif
if ret_val
   if sez
      set device to print
   else
      set print on
   endif
endif
return(ret_val)

* end function PrintOK()
*--------------------------------------------------------------------*

* eof printok.prg
