/*
     Program: Rainbow()
     System: GRUMPFISH LIBRARY
     Author: Greg Lief
     Copyright (c) 1988-93, Greg Lief
     CA-Clipper 5.01 version
     Compile instructions: clipper rainbow /n/w/a
     Compile with "/dMOUSE" for mouseability
     Displays character string in continuously falling rainbow format
*/

#include "grump.ch"
#include "inkey.ch"

function rainbow(cString)
static aColors := { 'W', 'BR', 'R', 'GR', 'BG', 'B', 'G' }
local whichcolor := 0
local nStart := 3
local nRow
local mainloop := .t.
local nBottom := maxrow() - 6

#ifdef MOUSE
local nMidCol := maxcol() / 2
local nLength := len(cString) / 2
local aPos
local lReset  := .f.
#endif

GFSaveEnv(, 0)                  // shut off cursor
do while mainloop
   for nRow := nStart to nStart + 2
      #ifdef MOUSE
      aPos := GetMousePos()
      if aPos[1] == nRow .and. abs( aPos[2] - nMidCol ) <= nLength
         SetMousePos(nRow-1, aPos[2])
         lReset := .t.
      endif
      #endif
      scrncenter(nRow, cString, '+' + aColors[++whichcolor % 7 + 1] + '/N')
      #ifdef MOUSE
      if lReset
         lReset := .f.
         SetMousePos(nRow, aPos[2])
      endif
      #endif
      if inkey(.03) <> 0
         mainloop := .f.
         exit
      endif
   next
   if nStart < nBottom
      nStart += 3
   else
      nStart := 3
   endif
enddo
GFRestEnv()
return nil

* end function Rainbow()
*--------------------------------------------------------------------*

* eof rainbow.prg
