/*
    Program: REC_LOCK()
    System: GRUMPFISH LIBRARY
    Author: Greg Lief
    Copyright (c) 1988-94, Greg Lief
    CA-Clipper 5.x Version
    Compile instructions: clipper reclock /n /w

    If you are using CA-Clipper 5.2 and wish to lock multiple
    records in the same work area, compile this file with the
    "/dCLIPPER52" command-line option (in addition to the ones
    listed above).

    Attempts to lock record in multi-user environment
*/

#include "grump.ch"
#include "inkey.ch"

function rec_lock(nRec)
local box_no
local buffer
local firstloop
local ret_val := .f.
local waitmsg := "record"
local key := 0
if len(alias()) > 0   // no database in use
   firstloop := .t.

   #ifdef MOUSE

   while key <> K_RIGHT_DOWN .and. key <> K_ESC .and. ! ret_val

   #else

   while key <> K_ESC .and. ! ret_val

   #endif

      #ifdef CLIPPER52

      if ( nRec == NIL .and. rlock() ) .or. dbrlock(nRec)

      #else

      if rlock()

      #endif

         ret_val := .t.

      elseif firstloop
         if yes_no('Cannot lock ' + waitmsg + ' at this time', ;
                   'Would you like to wait')
            gfsaveenv(.t.)
            firstloop := .f.
            kaleid(.t., waitmsg)
         else
            exit
         endif
      else
         kaleid(.f., waitmsg)
         key := lastkey()
      endif
   end
   if ! firstloop
      gfrestenv()
      if ret_val    // file locked successfully - give user aural feedback
         CHARGE
      endif
   endif
endif
return (ret_val)

* end function Rec_Lock()
*--------------------------------------------------------------------*

* eof reclock.prg
