/*
   SAVESETS.PRG
   Functions to save and restore all SET variables
   CA-Clipper 5.x version
   Compile instructions: clipper savesets /n/w/a
   Copyright (c) 1990-93 Greg Lief
*/

#include "grump.ch"

static aSetStack := {}       // will serve as SET stack

/*
    Function: GFSaveSets()
    Purpose:  Save all SET variables onto the SET stack
*/
function GFSaveSets
local xx
local aSettings[_SET_COUNT]
for xx := 1 to _SET_COUNT            /* see STD.CH for this */
   aSettings[xx] := set(xx)
next
aadd(aSetStack, aSettings)
return len(aSetStack)

* end of function GFSaveSets()
*--------------------------------------------------------------------*


/*
    Function: GFRestSets()
    Purpose:  Restore all SET variables from the SET stack
*/
function GFRestSets(ele)
local xx, aSettings
/* use LIFO (last item in array) if no parameter was passed */
default ele to len(aSetStack)
/* preclude empty array! */
if len(aSetStack) > 0 .and. ele <= len(aSetStack)
   aSettings := aSetStack[ele]
   for xx := 1 to _SET_COUNT            /* see STD.CH for this */
      set(xx, aSettings[xx])
   next
   /* truncate length of array only if using LIFO, i.e., no param passed */
   if ele == len(aSetStack) .and. pcount() = 0
      truncate(aSetStack)
   endif
endif
return nil

* end of function GFRestSets()
*--------------------------------------------------------------------*

* eof savesets.prg
