/*
    Program: TTY()
    System: GRUMPFISH LIBRARY
    Author: Greg Lief
    Copyright (c) 1988-93, Greg Lief
    CA-Clipper 5.x Version
    Compile instructions: clipper tty /n /w
    *Mouseable*
    Displays message on screen "teletype" style until keypress
*/

#include "grump.ch"

function tty(nRow, cMessage, nDelay, nStopCol)
local nTempCol := 0
local yy
local nMaxCol := maxcol()
local cOldScrn
if nStopCol == NIL
   cOldScrn := savescreen(nRow, 0, nRow, maxcol())
endif
if nRow <= maxrow()
   GFSaveEnv()
   // set sound and stop column if parameters were not passed
   default nDelay to 0
   default nStopCol to -1

   while ginkey() == 0 .and. nStopCol <> nTempCol
      @ nRow, nTempCol ssay chr(32) + ;
              if(nTempCol < nMaxCol, substr(cMessage, 1, nMaxCol-nTempCol), '')
      if nMaxCol - nTempCol < len(cMessage)
         @ nRow, 0 ssay substr(cMessage, nMaxCol + 1 - nTempCol, ;
                               len(cMessage) - nMaxCol + nTempCol)
      endif
      if nDelay == 0
         tone(MUSIC_TTY, 1)
      else
         for yy := 1 to nDelay
         next
      endif
      if nTempCol == nMaxCol
         nTempCol := 0
      else
         nTempCol++
      endif
   end

   GFRestEnv()
   // do not restore screen if stop column was passed
   if nStopCol == NIL
      restscreen(nRow, 0, nRow, nMaxCol, cOldScrn)
   endif
endif
return NIL

* end function TTY()
*--------------------------------------------------------------------*

* eof tty.prg
