/*
   Function: WORLDUPPER()
   Author:   Greg Lief
   Copyright (c) 1990-93 Greg Lief
   Dialect:  CA-Clipper 5.x
   Purpose:  Converts a character string to upper-case, and handles
             seven special extended ASCII characters
   Syntax:   WorldUpper(<string to convert>)
   Returns:  Character string converted to uppercase
*/
function worldupper(mstring)
local nLength := len(mstring)
local x
local mchr
local ele
local cRetVal := []
static codes_ := { { 129, 154 }, { 130, 144 }, { 132, 142 }, ;
                   { 134, 143 }, { 135, 128 }, { 145, 146 }, ;
                   { 148, 153 }, { 164, 165 }, { 237, 233 } }
for x := 1 to nLength
   mchr := asc(substr(mstring, x, 1))
   do case
      *** lower-case letter key
      case mchr > 96 .and. mchr < 123
         cRetVal += chr(mchr - 32)

      case (ele := ascan(codes_, { | x | x[1] == mchr} ) ) > 0
         cRetVal += chr(codes_[ele, 2])

      otherwise
         cRetVal += chr(mchr)

   endcase
next
return cRetVal

* eof: wupper.prg
